; 	Christmas 2022 Star/snowflake size compo.     Entry by Bushy555.
;	For the VZ200/VZ300/Laser210/Laser310 Z80 8-bit platform.
;
;	The VZ/Laser uses the 6847 video chip, which, in text mode, only supports 32 chars wide by 16 chars height.
;	Therefore the first few lines of the 17 char height snowflake/star symbol scrolls off the screen.
;
; 	Assemble with PASMO assembler.
;		> PASMO VZENTRY.ASM VZENTRY.VZ
;
;
;
;
;       Header size		:  24 bytes.	  .VZ files have a 24 byte header. This is a fixed set size.
; 	Total code size 	:  85 bytes. 
;				------------
; 	Total overall size	: 109 bytes.
;				------------
;
;
; 
;
;
; 	No effort was put into thinking of a fancy way to display this.
;	Just attempted to display the entire snowflake in some sort of an runtime length encoded gibberish.
; 	Uses VZ ROM display character routine located at 0x33A.  Reg A = char to display.
; 	No doubt there is a nice way of XOR'ing A to flip from a displayed '*' to 'space' where necessary.
;
;
;
;	Source			: BUSHY_VZ200_ASM-BINARY_VC2022.ASM				(plain text)
;	Readable TXT		: BUSHY_VZ200_ASM-BINARY_VC2022.ASM				(plain text)
; 	Smallest size source 	: BUSHY_VZ200_ASM-BINARY_VC2022_minimal-source-listing.TXT	(plain text)
; 	Executable		: BUSHY_VZ200_ASM-BINARY_VC2022.VZ	(Executable binary for VZ emulator, such as "VZEM")
;
;
;

	org	$8000-24

	defb	'VZF1'			; HEADER: vzmagic       	[04]
	defb	'FILENAME.VZ      '    	; HEADER: filename      	[17]
	defb	$F1			; HEADER: Filetype      	[01]
	defw	$8000			; HEADER: Start address 	[02]

	org	$8000			; *** Start of program execution at $8000.
	ld	hl, table
	ld	b, 17		; 17 high
@l1:	push	bc
	ld	b, 2		; ...by 2 lots of bytes wide. Tried doing a single word but I failed.
	ld	d, (hl)		; capture first byte of line for the two extra x's sitting in third byte colomn.
@l2:	ld	c, (hl)
	push	bc
	ld	b, 8		; loop for all 8 bits within each byte.
@l3:	bit	7, c		; test bit.
	ld	a, " "		; print space
	jr	z, print
print2:	ld	a, "*"		; Else if '1' then print 'X'
print:	call	$33A		; call print char rom routine
	sla	c		; rotate yo
	djnz	@l3		; loop 1
    	pop	bc
	inc	hl		; next byte.
	djnz	@l2		; loop 2.
	ld	a, d		; display extra X if first byte = 255.
	inc	a		; INC A is half the size of : CP 255
	jr	nz, here
	ld	a, "*"		; print the extra X
	call	$33A			
here:	ld	a, $0d		; After 3 chars, display a <CR>
	call	$33A
	pop	bc
	djnz	@l1		; loop 3. For to next for 17 vertical height.
endy:	jr 	endy		; loop de loop.

table:	db %00001000,%00001000	; Data. 17-high x 16-wide.
	db %00001100,%00011000
	db %00001110,%00111000
	db %00001111,%01111000
	db %11111111,%11111111	; extra X should go here. ld a,d / inc a deals with this.
	db %01111111,%11111111
	db %00111111,%11111110
	db %00011111,%11111100
	db %00001111,%11111000
	db %00011111,%11111100
	db %00111111,%11111110
	db %01111111,%11111111
	db %11111111,%11111111	; extra X should go here. ld a,d / inc a deals with this.
	db %00001111,%01111000
	db %00001110,%00111000
	db %00001100,%00011000
	db %00001000,%00001000

